package io.zipcoder;

import java.util.concurrent.locks.Lock;
import java.util.concurrent.locks.ReadWriteLock;
import java.util.concurrent.locks.ReentrantReadWriteLock;

/**
 * Make this extend the Copier like `UnsafeCopier`, except use locks to make sure that the actual intro gets printed
 * correctly every time.  Make the run method thread safe.
 */
public class SafeCopier extends UnsafeCopier {

    ReadWriteLock lock;
    public SafeCopier(String toCopy) {
        super(toCopy);
        lock = new ReentrantReadWriteLock();
    }




    public void run() {
        lock.writeLock().lock();
        lock.readLock().lock();
        try
        {
            while(stringIterator.hasNext()){
                copied += stringIterator.next() + " ";
            }
        }
        finally
        {
            lock.readLock().unlock();
            lock.writeLock().unlock();
        }

    }
}
